﻿// SearchMissedFootnotes[CS6 - CC+].jsx
// 13.03.2021

//
// © Иванюшин М.Ю., 2021 ivanyushin#yandex.ru   |   dotextok.ru
// 
// Скрипт предназаначен для поиска потерянных сносок.
// В облачных версиях появилась напасть -- в структуре данных индизайна сноска есть, но в верстке нет.
// Что если искать текст сноски и проверять -- есть ли у него родительский фрейм.
// Если есть, всё в порядке, сноска на полосе. Если нет -- значит, текст сноски только в структуре данных индизайна, но не на полосе.

#include "Search_fn.jsxinc"

var programTitul = test_fn_precense; // "Проверка присутствия сносок 13.03.2021";
/////
lets_start(); 
var fnOptions = myDoc.footnoteOptions; 
var start = fnOptions.startAt;
var fIndex;
var pN;
var test;
var infoText = "";
var pBar = new ProgressBar(programTitul);
pBar.reset(story.footnotes.length);
for (var i = 0, st = start; i < story.footnotes.length; i++, st++, pBar.hit()) { // i++
      fIndex = story.footnotes[i].storyOffset.index;
      try{
          pN = story.insertionPoints[fIndex].parentTextFrames[0].parentPage.name;
          }
      catch (e) {
          pBar.close();
          alert("Похоже, фрейм статьи размещён на рабочем столе. Работа скрипта прекращена." , programTitul);
          exit();
          }
      try {
          test = story.footnotes[i].texts[0].parentTextFrames[0].isValid;
          }
      catch (e) {
          infoText += "Сноска " + st + ", страница " + pN + "\r";
          } 
    } // i++
pBar.close();
if (infoText.length == 0) {
     alert ("Все сноски на месте.", programTitul);    
    }
else alert ("Есть потерянные сноски:\r\r" + infoText + "\rЗапустите скрипт DisappearedFootnotes.jsx для их возвращения.", programTitul);
exit();
