﻿// DisappearedFootnotes.jsx
// 13.03.2021

// https://forum.rudtp.ru/threads/propadajut-snoski.75265/
//  Странность -- сноски в тексте есть, но на экране их нет.
// Попытка инициировать пересчёт макета:
// в выделенном тексте для каждого текстового фрейма:
//  a) узнаётся его высота
//  б) высота увеличивается на 1 единицы измерения
//  в) восстанавливается прежняя высота

// Возможно, этого будет достаточно, чтобы возвращать все исчезнувшие сноски. 
//  Можно делать для профилактики, раз такой непредсказуемый косяк появился в индизайне 2020.

// © Михаил Иванюшин, 2020  |  dotextok@gmail.com  |  dotextok.ru 

#include "Search_fn.jsxinc"

var pBar;
var programTitul = missed_fn; // "Поиск исчезнувших сносок";
lets_start();
var storyTextContainers=story.textContainers;
var tcLength = storyTextContainers.length;
pBar = new ProgressBar(programTitul);
pBar.reset(tcLength);
for (i = tcLength-1; i >= 0; i--, pBar.hit()) { // i--
    var tc = storyTextContainers[i];
    var gB = tc.geometricBounds;
    var yT = gB[0];
    var xT = gB[1];
    var yB = gB[2];
    var xB = gB[3];
    tc.geometricBounds = [yT,xT,yB+1,xB];
    tc.geometricBounds = [yT,xT,yB,xB]; 
    } // i--
pBar.close();
app.documents[0].select(NothingEnum.nothing);
story.recompose();


